--Create Similarity Function(Jaro Winkler)

set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go

CREATE FUNCTION [dbo].[JaroWinkler](@str1_in varchar(max) , @str2_in varchar(max)) 
RETURNS float As 
BEGIN
      Declare @str1 varchar(max) ,  @str2 varchar(max) ,  @len_str1 int ,  @len_str2 int
      Declare @swap_len int ,  @max_len int , @m int , @i int , @j int
      Declare @f int , @z int , @tr int , @a1 varchar(max) , @a2 varchar(max)
      Declare @swap_str varchar(max) , @f1 bit , @f2 bit , @wcd float
      Declare @wrd float  , @wtr float , @common float , @jaro_value float    
      Declare @tempTable1 Table ([FID] [int] , [FStatus] [bit]    NOT NULL)
      Declare @tempTable2 Table ([FID] [int] , [FStatus] [bit]    NOT NULL)
      set @tr = 0

      Set @common = 0
      Set @jaro_value = 0

      --/ calling Cleansing function
      Set @str1 = [dbo].[clean_sting](@str1_in) 
      Set @str2 = [dbo].[clean_sting](@str2_in)

    Set @len_str1 = LEN(@str1)
    Set @len_str2 = LEN(@str2)
      
      if  @len_str1 > @len_str2
            begin
                  set @swap_len = @len_str2
                  set @len_str2 = @len_str1 
                  set @len_str1 = @swap_len 
                  set @swap_str = @str1
                  set @str1 = @str2
                  set @str2 = @swap_str
            end

      set @max_len = @len_str2

      Declare @iCounter int
      Set @iCounter = 1 
      
      while(@iCounter <= @len_str1)
            Begin             
                  insert into @tempTable1 values(@iCounter,0)                 
                  Set @iCounter = @iCounter + 1
            End
      Set @iCounter = 1
       
      while(@iCounter <= @len_str2)
            Begin
                  insert into @tempTable2 values(@iCounter,0)                 
                  Set @iCounter = @iCounter + 1             
            End
      Set @iCounter = 1 
      Set @m = ROUND((@max_len / 2) - 1,1)
      set @i=1
      set @i = 1
      while(@i <= @len_str1)
                  Begin
                        Set @a1 = SubString(@str1,@i,1)

                        if @m >= @i 
                              Begin
                                    set @f = 1
                                    set @z = @i + @m
                              End
                        else
                              Begin
                                    set @f = @i - @m
                                    set @z = @i + @m
                              End

                        if @z > @max_len
                        Begin
                              set @z      = @max_len
                        End
                        while(@f <= @z)
                              Begin
                                    Set @a2 = SubString(@str2, @f, 1)
                                    Declare @valStatus bit
                                    Select  @valStatus=[FStatus]  from @tempTable2 Where [FID] = @f
                                          if((@a2 = @a1) and (@valStatus = 0))
                                                Begin
                                                  Set @common = @common + 1
                                                  Update @tempTable1 set [FStatus] = 1 Where [FID] = @i
                                                  Update @tempTable2 set [FStatus] = 1 Where [FID] = @f
                                                  Goto linea_exit
                                                End
                              set @f = @f + 1         
                              end
                        linea_exit:
                        set @i = @i + 1
                  End
          
            set @i = 1
            set @z = 1
            
            while(@i <= @len_str1)
                  Begin
                        Declare @v1Status bit
                        set @v1Status = 0
                        Select @v1Status=[FStatus]  from @tempTable1 Where [FID] = @i
                        
                        if(@v1Status = 1)
                              Begin
                                    while(@z <= @len_str2)                                
                                    Begin
                                          Declare @v2Status bit
                                          set @v2Status = 0
                                          Select @v2Status=[FStatus] from @tempTable2 Where [FID] = @z
                                          if(@v2Status = 1)
                                                Begin
                                                      set @z = @j + 1
                                                      Set @a1 = SubString(@str1, @i, 1)
                                                      Set @a2 = SubString(@str2, @z, 1)
                                                      if(@a1 <> @a2)
                                                            Begin
                                                                  set @tr = @tr + 0.5
                                                            End
                                                      Goto j_loop
                                                End
                                          set @z = @z + 1
                                    End
                              j_loop:
                              End
                        set @i = @i + 1
                  End

            Set @wcd = 1.0 / 3.0 
            Set @wrd = 1.0 / 3.0 
            Set @wtr = 1.0 / 3.0
            if @common <> 0
                  begin
                        Set @jaro_value = @wcd * @common / @len_str1 + @wrd * @common / @len_str2 +  @wtr * (@common - @tr) / @common
                  end
      return @jaro_value
end
--Create Cleansing Function to remove special characters and standardize values(Company or Corportation) = CO
set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go


 

CREATE Function [dbo].[Cleansing](@p_str1 varchar(max)) 
Returns varchar(max) as 
      Begin 
            Declare @ret_value varchar(max)
            set @ret_value = @p_str1
            set   @ret_value = REPLACE(@ret_value, '.', '')
            set   @ret_value = REPLACE(@ret_value, ',', '') 
            set   @ret_value = REPLACE(@ret_value, '-', '') 
            set   @ret_value = REPLACE(@ret_value, ';', '') 
            set   @ret_value = REPLACE(@ret_value, ':', '') 
             
            RETURN @ret_value
end


--For testing these function run

declare @i float
select  @i=[dbo].[JaroWinkler]('Peter','Pete')
print @i

declare @j float
select  @j =[dbo].[JaroWinkler]('Johnathan','Johnthan')
print @j


 